/* Routine for mergeing two populations */

# include <stdio.h>
# include <stdlib.h>
# include <math.h>

# include "global.h"
# include "rand.h"

/* Routine to merge two populations into one */
void merge (population *pop1, int size1, population *pop2, int size2, population *pop3)
{
    int i, k;

    for (i = 0; i < size1; i++)
    {
        copy_ind (&(pop1->ind[i]), &(pop3->ind[i]));
    }
    for (i = 0, k = size1; i < size2; i++, k++)
    {
        copy_ind (&(pop2->ind[i]), &(pop3->ind[k]));
    }
}

/* Routine to copy an individual 'ind1' into another individual 'ind2' */
void copy_ind (individual *ind1, individual *ind2)
{
    int i;

    if (nreal != 0)
    {
        for (i = 0; i < nreal; i++)
        {
            ind2->xreal[i] = ind1->xreal[i];
        }
    }
    for (i = 0; i < nobj; i++)
    {
        ind2->obj[i] = ind1->obj[i];
    }
	ind2->fitness = ind1->fitness;
}

void copy_pop (population *pop1, population *pop2, int size)
{
	int i;
	
	for(i = 0; i < size; i++)
	{
		copy_ind (&(pop1->ind[i]), &(pop2->ind[i]));
	}
}